(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.4' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     16934,        471]
NotebookOptionsPosition[     15335,        429]
NotebookOutlinePosition[     15720,        446]
CellTagsIndexPosition[     15677,        443]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{"Num", ":=", "5"}], "\[IndentingNewLine]", 
 RowBox[{"J", ":=", "2"}]}], "Input",
 CellChangeTimes->{{3.6935859807638817`*^9, 3.693585983921935*^9}, {
  3.693586440346279*^9, 3.693586440551991*^9}, {3.693586797419735*^9, 
  3.693586797795309*^9}, {3.69367507693713*^9, 3.693675078958584*^9}, {
  3.6936751713230963`*^9, 
  3.693675172976173*^9}},ExpressionUUID->"07ad18ac-f371-44cc-b8a7-\
b1033f2608c5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"K", "[", 
   RowBox[{"n_", ",", "m_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"KroneckerDelta", "[", 
     RowBox[{"n", ",", "m"}], "]"}], "*", 
    RowBox[{"(", 
     RowBox[{"sig", "^", "2"}], ")"}]}], "+", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"a", "[", "j", "]"}], "*", 
       RowBox[{"Exp", "[", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"c", "[", "j", "]"}]}], "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"t", "[", "m", "]"}], "-", 
           RowBox[{"t", "[", "n", "]"}]}], ")"}]}], "]"}], "*", 
       RowBox[{"Cos", "[", 
        RowBox[{
         RowBox[{"d", "[", "j", "]"}], "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"t", "[", "m", "]"}], "-", 
           RowBox[{"t", "[", "n", "]"}]}], ")"}]}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"b", "[", "j", "]"}], "*", 
       RowBox[{"Exp", "[", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"c", "[", "j", "]"}]}], "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"t", "[", "m", "]"}], "-", 
           RowBox[{"t", "[", "n", "]"}]}], ")"}]}], "]"}], "*", 
       RowBox[{"Sin", "[", 
        RowBox[{
         RowBox[{"d", "[", "j", "]"}], "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"t", "[", "m", "]"}], "-", 
           RowBox[{"t", "[", "n", "]"}]}], ")"}]}], "]"}]}]}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "1", ",", "J"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.693584669156992*^9, 3.693584793917544*^9}, {
  3.693585174661825*^9, 3.693585203070558*^9}, {3.693585744770568*^9, 
  3.693585754027095*^9}, {3.693585790692272*^9, 3.693585813611719*^9}, {
  3.693585924000257*^9, 3.693586034693701*^9}, {3.693587055118072*^9, 
  3.693587099094893*^9}},ExpressionUUID->"16013d0d-eb6e-4dee-b375-\
6da3647ce97a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"phi", "[", 
   RowBox[{"n_", ",", "j_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Exp", "[", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"c", "[", "j", "]"}]}], "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"t", "[", 
        RowBox[{"n", "+", "1"}], "]"}], "-", 
       RowBox[{"t", "[", "n", "]"}]}], ")"}]}], "]"}], "*", 
   RowBox[{"Cos", "[", 
    RowBox[{
     RowBox[{"d", "[", "j", "]"}], "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"t", "[", 
        RowBox[{"n", "+", "1"}], "]"}], "-", 
       RowBox[{"t", "[", "n", "]"}]}], ")"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.693585959085862*^9, 3.693585973087076*^9}, {
  3.69358604202284*^9, 
  3.6935860969872*^9}},ExpressionUUID->"ce14aea6-fe09-4231-9e49-c8a9c781c81c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"psi", "[", 
   RowBox[{"n_", ",", "j_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"-", 
    RowBox[{"Exp", "[", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"c", "[", "j", "]"}]}], "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"t", "[", 
         RowBox[{"n", "+", "1"}], "]"}], "-", 
        RowBox[{"t", "[", "n", "]"}]}], ")"}]}], "]"}]}], "*", 
   RowBox[{"Sin", "[", 
    RowBox[{
     RowBox[{"d", "[", "j", "]"}], "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"t", "[", 
        RowBox[{"n", "+", "1"}], "]"}], "-", 
       RowBox[{"t", "[", "n", "]"}]}], ")"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.693586107583213*^9, 3.6935861152834463`*^9}, 
   3.69358701157721*^9, 
   3.693588428490885*^9},ExpressionUUID->"a717a841-427a-48b2-84c4-\
40aec50118c5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"g", "[", 
   RowBox[{"n_", ",", "j_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"phi", "[", 
     RowBox[{"n", ",", "j"}], "]"}], "*", 
    RowBox[{"g", "[", 
     RowBox[{
      RowBox[{"n", "-", "1"}], ",", "j"}], "]"}]}], "+", 
   RowBox[{
    RowBox[{"phi", "[", 
     RowBox[{"n", ",", "j"}], "]"}], "*", 
    RowBox[{"x", "[", "n", "]"}]}], "+", 
   RowBox[{
    RowBox[{"psi", "[", 
     RowBox[{"n", ",", "j"}], "]"}], "*", 
    RowBox[{"h", "[", 
     RowBox[{
      RowBox[{"n", "-", "1"}], ",", "j"}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.693584748540875*^9, 3.693584757773735*^9}, {
  3.693584800680853*^9, 3.693584866423457*^9}, {3.6935861196966677`*^9, 
  3.693586138880851*^9}, {3.693588214139822*^9, 3.693588242062881*^9}, {
  3.693675657184019*^9, 
  3.6936756991275473`*^9}},ExpressionUUID->"77cb09c6-4e24-4082-a1e5-\
543c31d024b1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"h", "[", 
   RowBox[{"n_", ",", "j_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"phi", "[", 
     RowBox[{"n", ",", "j"}], "]"}], "*", 
    RowBox[{"h", "[", 
     RowBox[{
      RowBox[{"n", "-", "1"}], ",", "j"}], "]"}]}], "-", 
   RowBox[{
    RowBox[{"psi", "[", 
     RowBox[{"n", ",", "j"}], "]"}], "*", 
    RowBox[{"x", "[", "n", "]"}]}], "-", 
   RowBox[{
    RowBox[{"psi", "[", 
     RowBox[{"n", ",", "j"}], "]"}], "*", 
    RowBox[{"g", "[", 
     RowBox[{
      RowBox[{"n", "-", "1"}], ",", "j"}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.693586148042489*^9, 3.693586155434433*^9}, {
   3.693588229727425*^9, 3.69358824016696*^9}, 3.693588449817699*^9, {
   3.6936718184818*^9, 3.693671840926961*^9}, {3.6936756849597893`*^9, 
   3.6936756980004253`*^9}},ExpressionUUID->"21af7056-2fd4-4d8d-b4a1-\
eade76d3a32e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"u", "[", 
   RowBox[{"n_", ",", "j_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"phi", "[", 
     RowBox[{
      RowBox[{"n", "+", "1"}], ",", "j"}], "]"}], "*", 
    RowBox[{"u", "[", 
     RowBox[{
      RowBox[{"n", "+", "1"}], ",", "j"}], "]"}]}], "+", 
   RowBox[{
    RowBox[{"psi", "[", 
     RowBox[{
      RowBox[{"n", "+", "1"}], ",", "j"}], "]"}], "*", 
    RowBox[{"v", "[", 
     RowBox[{
      RowBox[{"n", "+", "1"}], ",", "j"}], "]"}]}], "+", 
   RowBox[{
    RowBox[{"a", "[", "j", "]"}], "*", 
    RowBox[{"x", "[", 
     RowBox[{"n", "+", "1"}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.693586162340496*^9, 3.693586188723634*^9}, {
  3.693586712710285*^9, 3.693586713029791*^9}, {3.6935882585277853`*^9, 
  3.693588264231743*^9}, {3.693588487155159*^9, 3.6935884873049726`*^9}, {
  3.693588784180262*^9, 3.693588784276186*^9}, {3.6936718503120403`*^9, 
  3.6936718508941927`*^9}, {3.693671941978218*^9, 3.69367194217671*^9}, {
  3.693674925045067*^9, 3.6936749301550503`*^9}, {3.693674970255026*^9, 
  3.693674970428817*^9}, {3.6936756161738577`*^9, 3.693675616900882*^9}, {
  3.693675703615991*^9, 3.69367570377528*^9}, {3.693682203502328*^9, 
  3.693682203707502*^9}, {3.693682303087367*^9, 
  3.6936823032546577`*^9}},ExpressionUUID->"9cda2f19-d521-4fa8-b1cc-\
f705e5f2042b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"v", "[", 
   RowBox[{"n_", ",", "j_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"phi", "[", 
     RowBox[{
      RowBox[{"n", "+", "1"}], ",", "j"}], "]"}], "*", 
    RowBox[{"v", "[", 
     RowBox[{
      RowBox[{"n", "+", "1"}], ",", "j"}], "]"}]}], "-", 
   RowBox[{
    RowBox[{"psi", "[", 
     RowBox[{
      RowBox[{"n", "+", "1"}], ",", "j"}], "]"}], "*", 
    RowBox[{"u", "[", 
     RowBox[{
      RowBox[{"n", "+", "1"}], ",", "j"}], "]"}]}], "-", 
   RowBox[{
    RowBox[{"b", "[", "j", "]"}], "*", 
    RowBox[{"x", "[", 
     RowBox[{"n", "+", "1"}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.693586191628832*^9, 3.6935862062683897`*^9}, {
  3.693586716021142*^9, 3.6935867162369747`*^9}, {3.6935867802066402`*^9, 
  3.693586780604396*^9}, {3.693588268938236*^9, 3.69358827299236*^9}, {
  3.693588454064271*^9, 3.693588489545074*^9}, {3.693588785516567*^9, 
  3.6935887856276293`*^9}, {3.69367186176719*^9, 3.693671889000947*^9}, {
  3.693671940008727*^9, 3.693671940217456*^9}, {3.6936749338375072`*^9, 
  3.693674933948295*^9}, {3.6936749711893272`*^9, 3.6936749713564053`*^9}, {
  3.6936756142553177`*^9, 3.6936756146450977`*^9}, {3.693675704919923*^9, 
  3.693675705071086*^9}, {3.693682205980433*^9, 3.6936822061632977`*^9}, {
  3.693682304031589*^9, 
  3.693682304190526*^9}},ExpressionUUID->"8bdd8aa3-b4e7-4474-ba73-\
bb9297d21164"],

Cell[BoxData[{
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"g", "[", 
     RowBox[{"0", ",", "j"}], "]"}], ":=", "0"}], ",", 
   RowBox[{"{", 
    RowBox[{"j", ",", "1", ",", "J"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"h", "[", 
     RowBox[{"0", ",", "j"}], "]"}], ":=", "0"}], ",", 
   RowBox[{"{", 
    RowBox[{"j", ",", "1", ",", "J"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"u", "[", 
     RowBox[{"Num", ",", "j"}], "]"}], ":=", "0"}], ",", 
   RowBox[{"{", 
    RowBox[{"j", ",", "1", ",", "J"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"v", "[", 
     RowBox[{"Num", ",", "j"}], "]"}], ":=", "0"}], ",", 
   RowBox[{"{", 
    RowBox[{"j", ",", "1", ",", "J"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.693586250768992*^9, 
  3.693586295457863*^9}},ExpressionUUID->"c8917587-ab73-450c-997e-\
e6364bc25aae"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Krow", "[", "i_", "]"}], ":=", 
  RowBox[{
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"K", "[", 
       RowBox[{"n", ",", "i"}], "]"}], "*", 
      RowBox[{"x", "[", "n", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"n", ",", "1", ",", "i"}], "}"}]}], "]"}], "+", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"K", "[", 
       RowBox[{"i", ",", "n"}], "]"}], "*", 
      RowBox[{"x", "[", "n", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"n", ",", 
       RowBox[{"i", "+", "1"}], ",", "Num"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.6935853511079683`*^9, 3.69358536053428*^9}, {
  3.693585592493231*^9, 3.693585635230188*^9}, {3.693585781092552*^9, 
  3.693585783556366*^9}},ExpressionUUID->"964fcb8b-8419-4142-b86d-\
ae0c7e1f0c4a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Kext", "[", "i_", "]"}], ":=", 
  RowBox[{
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"a", "[", "j", "]"}], "*", 
      RowBox[{"g", "[", 
       RowBox[{
        RowBox[{"i", "-", "1"}], ",", "j"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "1", ",", "J"}], "}"}]}], "]"}], "+", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"b", "[", "j", "]"}], "*", 
      RowBox[{"h", "[", 
       RowBox[{
        RowBox[{"i", "-", "1"}], ",", "j"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "1", ",", "J"}], "}"}]}], "]"}], "+", 
   RowBox[{
    RowBox[{"K", "[", 
     RowBox[{"i", ",", "i"}], "]"}], "*", 
    RowBox[{"x", "[", "i", "]"}]}], "+", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"phi", "[", 
       RowBox[{"i", ",", "j"}], "]"}], "*", 
      RowBox[{"u", "[", 
       RowBox[{"i", ",", "j"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "1", ",", "J"}], "}"}]}], "]"}], "+", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"psi", "[", 
       RowBox[{"i", ",", "j"}], "]"}], "*", 
      RowBox[{"v", "[", 
       RowBox[{"i", ",", "j"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "1", ",", "J"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.69358537053761*^9, 3.6935855338069468`*^9}, {
  3.693585677344488*^9, 3.6935856780401487`*^9}, {3.693586326573382*^9, 
  3.6935864021265173`*^9}, {3.693586882009677*^9, 3.693586885863969*^9}, {
  3.693586964143392*^9, 3.693586974758939*^9}, {3.693587501552188*^9, 
  3.693587503799451*^9}, {3.693588304026568*^9, 3.693588328455508*^9}, {
  3.693588384993482*^9, 3.693588398529613*^9}, {3.693588478393178*^9, 
  3.6935884811446877`*^9}, {3.693588777580611*^9, 3.693588779811514*^9}, {
  3.6936719014336843`*^9, 3.693671905879861*^9}, {3.6936749764380207`*^9, 
  3.6936749801970778`*^9}, {3.6936756072400103`*^9, 3.693675635412245*^9}, {
  3.6936757095060472`*^9, 3.693675715159864*^9}, {3.6936822100687723`*^9, 
  3.693682220044044*^9}, {3.693682294057961*^9, 
  3.6936822999988413`*^9}},ExpressionUUID->"0aa366ab-15b4-40da-a538-\
c2303d7319e7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"Krow", "[", "3", "]"}], "-", 
    RowBox[{"Kext", "[", "3", "]"}]}], ")"}], "]"}]], "Input",
 CellChangeTimes->{{3.693586899888627*^9, 3.693586908663422*^9}, {
  3.6935871117429256`*^9, 3.6935871605545063`*^9}, {3.693587215843622*^9, 
  3.693587221412312*^9}, {3.6935873131548233`*^9, 3.6935873249057217`*^9}, {
  3.6935874326226482`*^9, 3.693587435693698*^9}, {3.6935874837637672`*^9, 
  3.69358748641643*^9}, {3.6935875215280848`*^9, 3.693587553073897*^9}, {
  3.693588283600957*^9, 3.693588288648657*^9}, {3.693588348031178*^9, 
  3.693588354719151*^9}, {3.69358853341702*^9, 3.693588536673752*^9}, {
  3.693588588552197*^9, 3.6935886021989822`*^9}, {3.693588699132349*^9, 
  3.693588703683421*^9}, {3.69358875950032*^9, 3.693588762642273*^9}, {
  3.693671882952797*^9, 3.693671885376156*^9}, {3.6936749514365673`*^9, 
  3.693674998862646*^9}, {3.693675248293715*^9, 3.693675249490217*^9}, {
  3.693682281279174*^9, 
  3.693682292598113*^9}},ExpressionUUID->"2c6cefa3-29c0-4236-a724-\
88813dde99a8"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.693586916938942*^9, 3.693586997916997*^9, 3.693587028230118*^9, {
   3.693587104868126*^9, 3.693587160945237*^9}, {3.693587213464612*^9, 
   3.693587221638493*^9}, {3.6935873148092737`*^9, 3.6935873251441*^9}, 
   3.693587436035162*^9, {3.693587486823807*^9, 3.693587553645637*^9}, {
   3.6935882775956287`*^9, 3.6935883917760153`*^9}, {3.693588473633871*^9, 
   3.6935885013975153`*^9}, 3.6935885388323507`*^9, 3.693588605447826*^9, {
   3.693588642346089*^9, 3.6935886605912533`*^9}, {3.693588698062395*^9, 
   3.693588716958452*^9}, {3.693588763119618*^9, 3.693588791501815*^9}, {
   3.693671880720682*^9, 3.693671910471405*^9}, 3.6936719547417107`*^9, {
   3.693674937546693*^9, 3.693675001274563*^9}, {3.693675168932845*^9, 
   3.6936751932250357`*^9}, 3.6936752536237793`*^9, {3.693675635875647*^9, 
   3.693675645894446*^9}, {3.693675693062199*^9, 3.6936757204506283`*^9}, 
   3.693680943380818*^9, 3.693682232335704*^9, {3.693682287729724*^9, 
   3.6936823126281853`*^9}, 
   3.6936829603583527`*^9},ExpressionUUID->"a2c53481-0a6d-4e8f-9f4d-\
4e4d01d68c69"]
}, Open  ]]
},
WindowSize->{1212, 1031},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
Magnification:>1.5 Inherited,
FrontEndVersion->"11.1 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 16, \
2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 427, 8, 81, "Input", "ExpressionUUID" -> \
"07ad18ac-f371-44cc-b8a7-b1033f2608c5"],
Cell[988, 30, 1911, 54, 112, "Input", "ExpressionUUID" -> \
"16013d0d-eb6e-4dee-b375-6da3647ce97a"],
Cell[2902, 86, 791, 24, 49, "Input", "ExpressionUUID" -> \
"ce14aea6-fe09-4231-9e49-c8a9c781c81c"],
Cell[3696, 112, 825, 26, 49, "Input", "ExpressionUUID" -> \
"a717a841-427a-48b2-84c4-40aec50118c5"],
Cell[4524, 140, 902, 26, 49, "Input", "ExpressionUUID" -> \
"77cb09c6-4e24-4082-a1e5-543c31d024b1"],
Cell[5429, 168, 875, 25, 49, "Input", "ExpressionUUID" -> \
"21af7056-2fd4-4d8d-b4a1-eade76d3a32e"],
Cell[6307, 195, 1345, 33, 81, "Input", "ExpressionUUID" -> \
"9cda2f19-d521-4fa8-b1cc-f705e5f2042b"],
Cell[7655, 230, 1400, 34, 81, "Input", "ExpressionUUID" -> \
"8bdd8aa3-b4e7-4474-ba73-bb9297d21164"],
Cell[9058, 266, 1016, 34, 143, "Input", "ExpressionUUID" -> \
"c8917587-ab73-450c-997e-e6364bc25aae"],
Cell[10077, 302, 831, 24, 49, "Input", "ExpressionUUID" -> \
"964fcb8b-8419-4142-b86d-ae0c7e1f0c4a"],
Cell[10911, 328, 2178, 56, 112, "Input", "ExpressionUUID" -> \
"0aa366ab-15b4-40da-a538-c2303d7319e7"],
Cell[CellGroupData[{
Cell[13114, 388, 1084, 19, 49, "Input", "ExpressionUUID" -> \
"2c6cefa3-29c0-4236-a724-88813dde99a8"],
Cell[14201, 409, 1118, 17, 49, "Output", "ExpressionUUID" -> \
"a2c53481-0a6d-4e8f-9f4d-4e4d01d68c69"]
}, Open  ]]
}
]
*)

